<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" content="width=device-width, initial-scale=1.0">
    <title>selectbox country</title>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>

    <div class="container">
        <h2>Responsive Form</h2>
        <p>sample forms 02: multi colums</p>

        <form action="" class="jumbotron container" id="input-form">
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="voucher-code">countryCode</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="input-countryCode" name="countryCode" placeholder="country code"
                        class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="discount">countryName</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="input-countryName" name="countryName" placeholder="country name"
                        class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="note">region</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="input-region" name="region" placeholder="region" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="country">Country</label>
                </div>
                <div class="col-sm-3">
                    <select id="country-select" name="country" class="form-control">
                        <option value="0">chọn</option>
                    </select>
                </div>
                <div class="col-sm-3">
                    <label for="region">Region</label>
                </div>
                <div class="col-sm-3">
                    <select id="region-select" disabled name="region" class="form-control">
                    </select>
                </div>
            </div>
            <div class="row pull-right">
                <div class="col-sm-12">
                    <input type="button" value="Send" class="btn btn-info" id="send-button">
                    <button id="delete_data" class="btn btn-danger">Delete Data</button>
                    <button id="delete_data_all" class="btn btn-danger">Delete All Data</button>
                </div>
            </div>
        </form>
        <table class="table table-bordered table-striped table-hover" id="user-table">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>CountryCode</th>
                    <th>CountryName</th>
                    <th>Region</th>
                </tr>
        </table>
    </div>

    <script>

        var gID = "";
        var gFORM_MODE_INSERT = "Insert";
        var gFORM_MODE_UPDATE = "Update";
        var gFormMode = gFORM_MODE_INSERT;

        var table = $("#user-table").DataTable({
            "columns": [
                { "data": "id" },
                { "data": "countryCode" },
                { "data": "countryName" },
                { "data": "regions" },
            ]
        })

        $(document).on('click', "tr", function () {
            onBtnDetailClick(this);
        })

        $(document).on('click', "#delete_data", function () {
            onBtnDeleteClick(this);
        })

        $(document).on('click', "#delete_data_all", function () {
            onBtnAllDeleteClick(this);
        })

        $(document).on('click', "#send-button", function () {
            onBtnSaveDataClick(this)
        })
        //get data country
        $.ajax({
            url: "http://localhost:8080/country/all",
            type: "GET",
            success: function (res) {
                console.log(res)
                loadDataToCountrySelect(res)
                table.clear();
                table.rows.add(res);
                table.draw();
            },
            error: function (err) {
                console.log(err.status);
            }
        })

        var gSelectCountry = $("#country-select");
        //load data to select
        function loadDataToCountrySelect(paramCountry) {

            for (let i = 0; i < paramCountry.length; i++) {
                let bOptionCountry = $("<option>")
                bOptionCountry.val(paramCountry[i].countryCode);
                bOptionCountry.text(paramCountry[i].countryName);

                gSelectCountry.append(bOptionCountry);
            }
        }

        var gRegionSelectElement = $("#region-select");

        //callback function
        gSelectCountry.on("change", function () {
            gRegionSelectElement.html("");
            var bCountryCode = $(this).val();
            getRegionsByCountryCode(bCountryCode);
        });

        function getRegionsByCountryCode(pCountryCode) {
            $.ajax({
                url: "http://localhost:8080/region/countrycode?countryCode=" + pCountryCode,
                method: "GET",
                success: function (pObjRes) {
                    console.log(pObjRes);
                    loadDataToRegionSelect(pObjRes);
                },
                error: function (pXhrObj) {
                    console.log(pXhrObj);
                }
            });
        }

        function loadDataToRegionSelect(pRegionList) {
            if (pRegionList.length > 0) {
                gRegionSelectElement.prop("disabled", false);

                for (i = 0; i < pRegionList.length; i++) {
                    var bRegionOption = $("<option/>");
                    bRegionOption.prop("value", pRegionList[i].regionCode);
                    bRegionOption.prop("text", pRegionList[i].regionName);
                    gRegionSelectElement.append(bRegionOption);
                };
            } else {
                gRegionSelectElement.prop("disabled", "disabled");
            }
        }

        function onBtnDetailClick(paramElement) {

            gFormMode = gFORM_MODE_UPDATE;
            var vRowSelected = $(paramElement).closest("tr");
            var vTable = $("#user-table").DataTable();
            var vDataRow = vTable.row(vRowSelected).data();
            gID = vDataRow.id;
            $.ajax({
                url: "http://localhost:8080/country/update/" + gID,
                type: 'GET',
                success: function (res) {
                    console.log(res);
                    $("#input-countryCode").val(res.countryCode);
                    $("#input-countryName").val(res.countryName);
                },
                error: function (err) {
                    console.log(err.status)
                }
            })
        }

        function onBtnDeleteClick() {
				if(confirm("bạn có muốn xóa?") == true) {


					$.ajax({
						url: "http://localhost:8080/country/delete/" + gID,
						type: "DELETE",
						dataType: "json",
						success: function(res) {
							window.location.reload();
						},
						error: function(err) {
							console.log(err.response);
						}
					})
				}
			}

            function onBtnAllDeleteClick() {
				if(confirm("bạn có muốn xóa hết toàn bộ danh sách drink?") == true) {
					$.ajax({
						url: "http://localhost:8080/delete/all",
						type: "DELETE",
						dataType: "json",
						success: function(res) {
							window.location.reload();
						},
						error: function(err) {
							console.log(err.response);
						}
					})
				}
			}

            function onBtnSaveDataClick() {
				if (gFormMode === gFORM_MODE_UPDATE) {
					let vObjectRequest = {
						id: gID,
						countryCode: $("#input-countryCode").val(),
						countryName: $("#input-countryName").val(),
					};

					$.ajax({
						url: "http://localhost:8080/country/update/" + gID,
						contentType: "application/json; charset=UTF-8",
						type: 'PUT',
						dataType: "json",
						data: JSON.stringify(vObjectRequest),
						success: function (res) {
							window.location.reload();
						},
						error: function (err) {
							console.log(err.status)
						}
					})
				}else {
					let vObjectRequest = {
						id: gID,
						countryCode: $("#input-countryCode").val(),
						countryName: $("#input-countryName").val(),
					}
					$.ajax({
						url: "http://localhost:8080/country/create",
						contentType: "application/json; Charset=UFT-8",
						type: 'POST',
						dataType: "json",
						data: JSON.stringify(vObjectRequest),
						success: function (res) {
							window.location.reload();
						},
						error: function (err) {
							console.log(err.status)
						}
					})
				}
			}
    </script>
</body>

</html>